#include <Arduino.h>

#include "btn.h"



uint16_t btn_mask;
uint16_t btn_last;
uint16_t btn_flip;



void sr_send(uint16_t dat)
{
	digitalWrite(SR_LAT, LOW);

	uint16_t mask = 0x8000;

	for (uint8_t i = 0; i < 16; i++) {
		digitalWrite(SR_DAT, dat & mask ? HIGH : LOW);
		digitalWrite(SR_CLK, HIGH);
		mask >>= 1;
		digitalWrite(SR_CLK, LOW);
	}

	digitalWrite(SR_LAT, HIGH);
	__NOP(); __NOP();
	digitalWrite(SR_LAT, LOW);
}

uint16_t btn_read()
{
	btn_last = btn_mask;

	// read joystick only for now
	for (uint8_t i = 11; i < 16; i++) {
		sr_send(1 << i);
		btn_mask &= ~(1 << i);
		if (!digitalRead(BTN_READ1)) {
			btn_mask |= (1 << i);
		}
	}

	btn_flip = btn_mask ^ btn_last;

	return btn_flip & btn_mask;
}